Properties Methods Events Config Options Direct Link

    Observable
      TreeLoader

# Class Ext.tree.TreeLoader

Package: | Ext.tree
Defined In: | TreeLoader.js
Class: | TreeLoader
Extends: | Observable

A TreeLoader provides for lazy loading of an Ext.tree.TreeNode's child nodes from a specified URL. The response must be a JavaScript Array definition whose elements are node definition objects. eg:

    [{
            id: 1,
            text: 'A leaf Node',
            leaf: true
        },{
            id: 2,
            text: 'A folder Node',
            children: [{
                id: 3,
                text: 'A child Node',
                leaf: true
            }]
       }]

A server request is sent, and child nodes are loaded only when a node is expanded. The loading node's id is passed to the server under the parameter name "node" to enable the server to produce the correct child nodes.
To pass extra parameters, an event handler may be attached to the "beforeload" event, and the parameters specified in the TreeLoader's baseParams property:

    myTreeLoader.on("beforeload", function(treeLoader, node) {
            this.baseParams.category = node.attributes.category;
        }, this);

< This would pass an HTTP parameter called "category" to the server containing the value of the Node's "category" attribute.

## Config Options

Config Options | Defined By
--- | ---
| baseAttrs : Object (optional) An object containing attributes to be added to all nodes created by this loader. If the attributes sent by... (optional) An object containing attributes to be added to all nodes created by this loader. If the attributes sent by the server have an attribute in this object, they take priority. | TreeLoader
| baseParams : Object (optional) An object containing properties which specify HTTP parameters to be passed to each request for child nodes. | TreeLoader
| clearOnLoad : Boolean (optional) Default to true. Remove previously existing child nodes before loading. | TreeLoader
| dataUrl : String The URL from which to request a Json string which specifies an array of node definition objects representing the chil... The URL from which to request a Json string which specifies an array of node definition objects representing the child nodes to be loaded. | TreeLoader
| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable
| preloadChildren : Boolean If set to true, the loader recursively loads "children" attributes when doing the first load on nodes. | TreeLoader
| requestMethod : String The HTTP request method for loading data (defaults to 'POST'). | TreeLoader

uiProviders : Object
(optional) An object containing properties which specify custom Ext.tree.TreeNodeUI implementations. If the optional ...
(optional) An object containing properties which specify custom Ext.tree.TreeNodeUI implementations. If the optional uiProvider attribute of a returned child node is a string rather than a reference to a TreeNodeUI implementation, this that string value is used as a property name in the uiProviders object.

TreeLoader

| url : String Equivalent to dataUrl. | TreeLoader

## Public Properties

This class has no public properties.

## Public Methods

Method | Defined By
--- | ---

TreeLoader( `Object config` )
Creates a new Treeloader.
Creates a new Treeloader.
Parameters:

- `config` : Object
  A config object containing config properties.

Returns:

- ``

TreeLoader

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

createNode() : void
Override this function for custom TreeNode node implementation
Override this function for custom TreeNode node implementation
Parameters:

- None.

Returns:

- `void`

TreeLoader

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

load( `Ext.tree.TreeNode node`, `Function callback` ) : void
Load an Ext.tree.TreeNode from the URL specified in the constructor. This is called automatically when a node is expa...
Load an Ext.tree.TreeNode from the URL specified in the constructor. This is called automatically when a node is expanded, but may be used to reload a node (or append new children if the clearOnLoad option is false.)
Parameters:

- `node` : Ext.tree.TreeNode
- `callback` : Function

Returns:

- `void`

TreeLoader

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

## Public Events

Event | Defined By
--- | ---

beforeload : ( `Object This`, `Object node`, `Object callback` )
Fires before a network request is made to retrieve the Json text which specifies a node's children.
Fires before a network request is made to retrieve the Json text which specifies a node's children.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `callback` : Object
  The callback function specified in the load call.

TreeLoader

load : ( `Object This`, `Object node`, `Object response` )
Fires when the node has been successfuly loaded.
Fires when the node has been successfuly loaded.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `response` : Object
  The response object containing the data from the server.

TreeLoader

loadexception : ( `Object This`, `Object node`, `Object response` )
Fires if the network request failed.
Fires if the network request failed.
Listeners will be called with the following arguments:

- `This` : Object
  TreeLoader object.
- `node` : Object
  The Ext.tree.TreeNode object being loaded.
- `response` : Object
  The response object containing the data from the server.

TreeLoader